diff --git a/lib/url.c b/lib/url.c
index 38b9552f7a9d..fcba26b5e9e2 100644
--- a/lib/url.c
+++ b/lib/url.c
@@ -6252,6 +6252,17 @@ static CURLcode create_conn(struct Curl_easy *data,
     }
   }
 
+#ifdef USE_UNIX_SOCKETS
+  if(data->set.str[STRING_UNIX_SOCKET_PATH]) {
+    conn->unix_domain_socket = strdup(data->set.str[STRING_UNIX_SOCKET_PATH]);
+    if(conn->unix_domain_socket == NULL) {
+      result = CURLE_OUT_OF_MEMORY;
+      goto out;
+    }
+    conn->abstract_unix_socket = data->set.abstract_unix_socket;
+  }
+#endif
+
 #ifndef CURL_DISABLE_PROXY
   /*************************************************************
    * Extract the user and password from the authentication string
@@ -6306,17 +6317,10 @@ static CURLcode create_conn(struct Curl_easy *data,
   Curl_safefree(no_proxy);
 
 #ifdef USE_UNIX_SOCKETS
-  if(data->set.str[STRING_UNIX_SOCKET_PATH]) {
-    if(proxy) {
-      free(proxy); /* Unix domain sockets cannot be proxied, so disable it */
-      proxy = NULL;
-    }
-    conn->unix_domain_socket = strdup(data->set.str[STRING_UNIX_SOCKET_PATH]);
-    if(conn->unix_domain_socket == NULL) {
-      result = CURLE_OUT_OF_MEMORY;
-      goto out;
-    }
-    conn->abstract_unix_socket = data->set.abstract_unix_socket;
+  /* Unix domain sockets cannot be proxied (really?), so disable it */
+  if(proxy && conn->unix_domain_socket) {
+    free(proxy);
+    proxy = NULL;
   }
 #endif
 
